// ScreenCaptureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ScreenCapture.h"
#include "SetCursor.h"
#include "CaptureButton.h"
#include "ScreenCaptureDlg.h"
#include "dib.h"
#include "MouseHook.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static UINT UWM_HOOK = ::RegisterWindowMessage(UWM_HOOK_MSG);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScreenCaptureDlg dialog

CScreenCaptureDlg::CScreenCaptureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScreenCaptureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScreenCaptureDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScreenCaptureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScreenCaptureDlg)
	DDX_Control(pDX, IDC_CLEAR, c_Clear);
	DDX_Control(pDX, IDC_MESSAGES, c_Messages);
	DDX_Control(pDX, IDC_MENU, c_Menu);
	DDX_Control(pDX, IDC_COPY, c_Copy);
	DDX_Control(pDX, IDC_BITMAP, c_Bitmap);
	DDX_Control(pDX, IDC_PRINTSCREEN, c_PrintScreen);
	DDX_Control(pDX, IDC_NO1, c_No);
	DDX_Control(pDX, IDC_HAND1, c_Hand);
	DDX_Control(pDX, IDC_EDIT1, c_Edit);
	DDX_Control(pDX, IDC_BUTTON1, c_Button);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScreenCaptureDlg, CDialog)
        ON_REGISTERED_MESSAGE(UWM_HOOK, OnHookMessage)
	//{{AFX_MSG_MAP(CScreenCaptureDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_PRINTSCREEN, OnPrintscreen)
	ON_BN_CLICKED(IDC_COPY, OnCopy)
	ON_BN_CLICKED(IDC_BKCOLOR, OnBkcolor)
	ON_COMMAND(IDC_EXIT, OnExit)
	ON_COMMAND(IDC_PRINT, OnPrint)
	ON_COMMAND(IDC_BKCOLOR, OnBkcolor)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScreenCaptureDlg message handlers

BOOL CScreenCaptureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	c_No.SetWindowText(_T("NO!"));
	c_No.SetCursor(AfxGetApp()->LoadStandardCursor(IDC_NO));
	c_Hand.SetWindowText(_T("Hand"));
	c_Hand.SetCursor(AfxGetApp()->LoadCursor(IDC_HAND));
	c_Menu.SetMenuGrab(TRUE);
	
	map.AddMap(WM_NULL);		// 000
	map.AddMap(WM_CREATE);		// 001
	map.AddMap(WM_DESTROY);		// 002
	map.AddMap(WM_MOVE);		// 003
	map.AddMap(WM_SIZE);		// 005
	map.AddMap(WM_ACTIVATE);	// 006
	map.AddMap(WM_SETFOCUS);	// 007
	map.AddMap(WM_KILLFOCUS);	// 008
	map.AddMap(WM_ENABLE);		// 00A
	map.AddMap(WM_SETREDRAW);	// 00B
	map.AddMap(WM_SETTEXT);		// 00C
	map.AddMap(WM_GETTEXT);		// 00D
	map.AddMap(WM_GETTEXTLENGTH);	// 00E
	map.AddMap(WM_PAINT);		// 00F
	map.AddMap(WM_CLOSE);		// 010
	map.AddMap(WM_QUERYENDSESSION);	// 011
	map.AddMap(WM_QUIT);		// 012
	map.AddMap(WM_QUERYOPEN);	// 013
	map.AddMap(WM_ERASEBKGND);	// 014
	map.AddMap(WM_SYSCOLORCHANGE);	// 015
	map.AddMap(WM_ENDSESSION);	// 016
	map.AddMap(WM_SHOWWINDOW);	// 018
	map.AddMap(WM_WININICHANGE);	// 01A
	map.AddMap(WM_SETTINGCHANGE);	// 01B
	map.AddMap(WM_DEVMODECHANGE);	// 01C
	map.AddMap(WM_FONTCHANGE);	// 01D
	map.AddMap(WM_TIMECHANGE);	// 01E
	map.AddMap(WM_CANCELMODE);	// 01F
	map.AddMap(WM_SETCURSOR);	// 020
	map.AddMap(WM_MOUSEACTIVATE);	// 021
	map.AddMap(WM_CHILDACTIVATE);	// 022
	map.AddMap(WM_QUEUESYNC);	// 023
	map.AddMap(WM_GETMINMAXINFO);	// 024
	map.AddMap(WM_PAINTICON);	// 026
	map.AddMap(WM_ICONERASEBKGND);	// 027
	map.AddMap(WM_NEXTDLGCTL);	// 028
	map.AddMap(WM_SPOOLERSTATUS);	// 02A
	map.AddMap(WM_DRAWITEM);	// 02B
	map.AddMap(WM_MEASUREITEM);	// 02C
	map.AddMap(WM_DELETEITEM);	// 02D
	map.AddMap(WM_VKEYTOITEM);	// 02E
	map.AddMap(WM_CHARTOITEM);	// 02F
	map.AddMap(WM_SETFONT);		// 030
	map.AddMap(WM_GETFONT);		// 031
	map.AddMap(WM_SETHOTKEY);	// 032
	map.AddMap(WM_GETHOTKEY);	// 033
	map.AddMap(WM_QUERYDRAGICON);	// 037
	map.AddMap(WM_COMPAREITEM);	// 039
#ifdef WM_GETOBJECT
	map.AddMap(WM_GETOBJECT);	// 03D
#endif
	map.AddMap(WM_COMPACTING);	// 041
	map.AddMap(WM_COMMNOTIFY);	// 044
	map.AddMap(WM_WINDOWPOSCHANGING); // 046
	map.AddMap(WM_WINDOWPOSCHANGED);// 047
	map.AddMap(WM_POWER);		// 048
	map.AddMap(WM_COPYDATA);	// 04A
	map.AddMap(WM_CANCELJOURNAL);	// 04B
	map.AddMap(WM_NOTIFY);		// 04E
	map.AddMap(WM_INPUTLANGCHANGEREQUEST); // 050
	map.AddMap(WM_INPUTLANGCHANGE);	// 051
	map.AddMap(WM_TCARD);		// 052
	map.AddMap(WM_HELP);		// 053
	map.AddMap(WM_USERCHANGED);	// 054
	map.AddMap(WM_NOTIFYFORMAT);	// 055
	map.AddMap(WM_CONTEXTMENU);	// 07B
	map.AddMap(WM_STYLECHANGING);	// 07C
	map.AddMap(WM_STYLECHANGED);	// 07D
	map.AddMap(WM_DISPLAYCHANGE);	// 07E
	map.AddMap(WM_GETICON);		// 07F
	map.AddMap(WM_SETICON);		// 080
	map.AddMap(WM_NCCREATE);	// 081
	map.AddMap(WM_NCDESTROY);	// 082
	map.AddMap(WM_NCCALCSIZE);	// 083
	map.AddMap(WM_NCHITTEST);	// 084
	map.AddMap(WM_NCPAINT);		// 085
	map.AddMap(WM_NCACTIVATE);	// 086
	map.AddMap(WM_GETDLGCODE);	// 087
	map.AddMap(WM_SYNCPAINT);	// 088
	map.AddMap(WM_NCMOUSEMOVE);	// 0A0
	map.AddMap(WM_NCLBUTTONDOWN);	// 0A1
	map.AddMap(WM_NCLBUTTONUP);	// 0A2
	map.AddMap(WM_NCLBUTTONDBLCLK);	// 0A3
	map.AddMap(WM_NCRBUTTONDOWN);	// 0A4
	map.AddMap(WM_NCRBUTTONUP);	// 0A5
	map.AddMap(WM_NCRBUTTONDBLCLK);	// 0A6
	map.AddMap(WM_NCMBUTTONDOWN);	// 0A7
	map.AddMap(WM_NCMBUTTONUP);	// 0A8
	map.AddMap(WM_NCMBUTTONDBLCLK);	// 0A9
	map.AddMap(SBM_SETPOS);		// 0E0
	map.AddMap(SBM_GETPOS);		// 0E1
	map.AddMap(SBM_SETRANGE);	// 0E2
	map.AddMap(SBM_GETRANGE);	// 0E3
#ifdef SBM_ENABLEARROWS
	map.AddMap(SBM_ENABLEARROWS);	// 0E4
#endif
	map.AddMap(SBM_SETRANGEREDRAW);	// 0E6
	map.AddMap(SBM_SETSCROLLINFO);	// 0E9
	map.AddMap(SBM_GETSCROLLINFO);	// 0EA
	map.AddMap(WM_KEYDOWN);		// 100
	map.AddMap(WM_KEYUP);		// 101
	map.AddMap(WM_CHAR);		// 102
	map.AddMap(WM_DEADCHAR);	// 103
	map.AddMap(WM_SYSKEYDOWN);	// 104
	map.AddMap(WM_SYSKEYUP);	// 105
	map.AddMap(WM_SYSCHAR);		// 106
	map.AddMap(WM_SYSDEADCHAR);	// 107
	map.AddMap(WM_IME_STARTCOMPOSITION);  // 10D
	map.AddMap(WM_IME_ENDCOMPOSITION); // 10E
	map.AddMap(WM_IME_COMPOSITION);	// 10F
	map.AddMap(WM_INITDIALOG);	// 110
	map.AddMap(WM_COMMAND);		// 111
	map.AddMap(WM_SYSCOMMAND);	// 112
	map.AddMap(WM_TIMER);		// 113
	map.AddMap(WM_HSCROLL);		// 114
	map.AddMap(WM_VSCROLL);		// 115
	map.AddMap(WM_INITMENU);	// 116
	map.AddMap(WM_INITMENUPOPUP);	// 117
	map.AddMap(WM_MENUSELECT);	// 11F
	map.AddMap(WM_MENUCHAR);	// 120
	map.AddMap(WM_ENTERIDLE);	// 121
#ifdef WM_MENURBUTTONUP
	map.AddMap(WM_MENURBUTTONUP);	// 122
#endif
#ifdef WM_MENUDRAG
	map.AddMap(WM_MENUDRAG);	// 123
#endif
#ifdef WM_MENUGETOBJECT
	map.AddMap(WM_MENUGETOBJECT);	// 124
#endif
#ifdef WM_UNINITMENUPOPUP
	map.AddMap(WM_UNINITMENUPOPUP);	// 125
#endif
#ifdef WM_MENUCOMMAND
	map.AddMap(WM_MENUCOMMAND);	// 126
#endif
	map.AddMap(WM_CTLCOLORMSGBOX);	// 132
	map.AddMap(WM_CTLCOLOREDIT);	// 133
	map.AddMap(WM_CTLCOLORLISTBOX);	// 134
	map.AddMap(WM_CTLCOLORBTN);	// 135
	map.AddMap(WM_CTLCOLORDLG);	// 136
	map.AddMap(WM_CTLCOLORSCROLLBAR); // 137
	map.AddMap(WM_CTLCOLORSTATIC);	// 138
	map.AddMap(CB_GETEDITSEL);	// 140
	map.AddMap(CB_LIMITTEXT);	// 141
	map.AddMap(CB_SETEDITSEL);	// 142
	map.AddMap(CB_ADDSTRING);	// 143
	map.AddMap(CB_DELETESTRING);	// 144
	map.AddMap(CB_DIR);		// 145
	map.AddMap(CB_GETCOUNT);	// 146
	map.AddMap(CB_GETCURSEL);	// 147
	map.AddMap(CB_GETLBTEXT);	// 148
	map.AddMap(CB_GETLBTEXTLEN);	// 149
	map.AddMap(CB_INSERTSTRING);	// 14A
	map.AddMap(CB_RESETCONTENT);	// 14B
	map.AddMap(CB_FINDSTRING);	// 14C
	map.AddMap(CB_SELECTSTRING);	// 14D
	map.AddMap(CB_SETCURSEL);	// 14E
	map.AddMap(CB_SHOWDROPDOWN);	// 14F
	map.AddMap(CB_GETITEMDATA);	// 150
	map.AddMap(CB_SETITEMDATA);	// 151
	map.AddMap(CB_GETDROPPEDCONTROLRECT); // 152
	map.AddMap(CB_SETITEMHEIGHT);	// 153
	map.AddMap(CB_GETITEMHEIGHT);	// 154
	map.AddMap(CB_SETEXTENDEDUI);	// 155
	map.AddMap(CB_GETEXTENDEDUI);	// 156
	map.AddMap(CB_GETDROPPEDSTATE);	// 157
	map.AddMap(CB_FINDSTRINGEXACT);	// 158
	map.AddMap(CB_SETLOCALE);	// 159
	map.AddMap(CB_GETLOCALE);	// 15A
	map.AddMap(CB_GETTOPINDEX);	// 15B
	map.AddMap(CB_SETTOPINDEX);	// 15C
	map.AddMap(CB_GETHORIZONTALEXTENT); // 15D
	map.AddMap(CB_SETHORIZONTALEXTENT); // 15E
	map.AddMap(CB_GETDROPPEDWIDTH);	// 15F
	map.AddMap(CB_SETDROPPEDWIDTH);	// 160
	map.AddMap(CB_INITSTORAGE);	// 161
	map.AddMap(LB_ADDSTRING);	// 180
	map.AddMap(LB_INSERTSTRING);	// 181
	map.AddMap(LB_DELETESTRING);	// 182
	map.AddMap(LB_SELITEMRANGEEX);	// 183
	map.AddMap(LB_RESETCONTENT);	// 184
	map.AddMap(LB_SETSEL);		// 185
	map.AddMap(LB_SETCURSEL);	// 186
	map.AddMap(LB_GETSEL);		// 187
	map.AddMap(LB_GETCURSEL);	// 188
	map.AddMap(LB_GETTEXT);		// 189
	map.AddMap(LB_GETTEXTLEN);	// 18A
	map.AddMap(LB_GETCOUNT);	// 18B
	map.AddMap(LB_SELECTSTRING);	// 18C
	map.AddMap(LB_DIR);		// 18D
	map.AddMap(LB_GETTOPINDEX);	// 18E
	map.AddMap(LB_FINDSTRING);	// 18F
	map.AddMap(LB_GETSELCOUNT);	// 190
	map.AddMap(LB_GETSELITEMS);	// 191
	map.AddMap(LB_SETTABSTOPS);	// 192
	map.AddMap(LB_GETHORIZONTALEXTENT); // 193
	map.AddMap(LB_SETHORIZONTALEXTENT); // 194
	map.AddMap(LB_SETCOLUMNWIDTH);	// 195
	map.AddMap(LB_ADDFILE);		// 196
	map.AddMap(LB_SETTOPINDEX);	// 197
	map.AddMap(LB_GETITEMRECT);	// 198
	map.AddMap(LB_GETITEMDATA);	// 199
	map.AddMap(LB_SETITEMDATA);	// 19A
	map.AddMap(LB_SELITEMRANGE);	// 19B
	map.AddMap(LB_SETANCHORINDEX);	// 19C
	map.AddMap(LB_GETANCHORINDEX);	// 19D
	map.AddMap(LB_SETCARETINDEX);	// 19E
	map.AddMap(LB_GETCARETINDEX);	// 19F
	map.AddMap(LB_SETITEMHEIGHT);	// 1A0
	map.AddMap(LB_GETITEMHEIGHT);	// 1A1
	map.AddMap(LB_FINDSTRINGEXACT);	// 1A2
	map.AddMap(LB_SETLOCALE);	// 1A5
	map.AddMap(LB_GETLOCALE);	// 1A6
	map.AddMap(LB_SETCOUNT);	// 1A7
	map.AddMap(LB_INITSTORAGE);	// 1A8
	map.AddMap(LB_ITEMFROMPOINT);	// 1A9
	map.AddMap(WM_MOUSEMOVE);	// 200
	map.AddMap(WM_LBUTTONDOWN);	// 201
	map.AddMap(WM_LBUTTONUP);	// 202
	map.AddMap(WM_LBUTTONDBLCLK);	// 203
	map.AddMap(WM_RBUTTONDOWN);	// 204
	map.AddMap(WM_RBUTTONUP);	// 205
	map.AddMap(WM_RBUTTONDBLCLK);	// 206
	map.AddMap(WM_MBUTTONDOWN);	// 207
	map.AddMap(WM_MBUTTONUP);	// 208
	map.AddMap(WM_MBUTTONDBLCLK);	// 209
	map.AddMap(WM_MOUSEWHEEL);	// 20A
	map.AddMap(WM_PARENTNOTIFY);	// 210
	map.AddMap(WM_ENTERMENULOOP);	// 211
	map.AddMap(WM_EXITMENULOOP);	// 212
	map.AddMap(WM_NEXTMENU);	// 213
	map.AddMap(WM_SIZING);		// 214
	map.AddMap(WM_CAPTURECHANGED);	// 215
	map.AddMap(WM_MOVING);		// 216
	map.AddMap(WM_POWERBROADCAST);	// 218
	map.AddMap(WM_DEVICECHANGE);	// 219
	map.AddMap(WM_MDICREATE);	// 220
	map.AddMap(WM_MDIDESTROY);	// 221
	map.AddMap(WM_MDIACTIVATE);	// 222
	map.AddMap(WM_MDIRESTORE);	// 223
	map.AddMap(WM_MDINEXT);		// 224
	map.AddMap(WM_MDIMAXIMIZE);	// 225
	map.AddMap(WM_MDITILE);		// 226
	map.AddMap(WM_MDICASCADE);	// 227
	map.AddMap(WM_MDIICONARRANGE);	// 228
	map.AddMap(WM_MDIGETACTIVE);	// 229
	map.AddMap(WM_MDISETMENU);	// 230
	map.AddMap(WM_ENTERSIZEMOVE);	// 231
	map.AddMap(WM_EXITSIZEMOVE);	// 232
	map.AddMap(WM_DROPFILES);	// 233
	map.AddMap(WM_MDIREFRESHMENU);	// 234
	map.AddMap(WM_IME_SETCONTEXT);	// 281
	map.AddMap(WM_IME_NOTIFY);	// 282
	map.AddMap(WM_IME_CONTROL);	// 283
	map.AddMap(WM_IME_COMPOSITIONFULL); // 284
	map.AddMap(WM_IME_SELECT);	// 285
	map.AddMap(WM_IME_CHAR);	// 286
#ifdef WM_IME_REQUEST
	map.AddMap(WM_IME_REQUEST);	// 288
#endif
	map.AddMap(WM_IME_KEYDOWN);	// 290
	map.AddMap(WM_IME_KEYUP);	// 291
	map.AddMap(WM_MOUSEHOVER);	// 2A1
	map.AddMap(WM_MOUSELEAVE);	// 2A3
	map.AddMap(WM_CUT);		// 300
	map.AddMap(WM_COPY);		// 301
	map.AddMap(WM_PASTE);		// 302
	map.AddMap(WM_CLEAR);		// 303
	map.AddMap(WM_UNDO);		// 304
	map.AddMap(WM_RENDERFORMAT);	// 305
	map.AddMap(WM_RENDERALLFORMATS);// 306
	map.AddMap(WM_DESTROYCLIPBOARD);// 307
	map.AddMap(WM_DRAWCLIPBOARD);	// 308
	map.AddMap(WM_PAINTCLIPBOARD);	// 309
	map.AddMap(WM_VSCROLLCLIPBOARD);// 30A
	map.AddMap(WM_SIZECLIPBOARD);	// 30B
	map.AddMap(WM_ASKCBFORMATNAME);	// 30C
	map.AddMap(WM_CHANGECBCHAIN);	// 30D
	map.AddMap(WM_HSCROLLCLIPBOARD);// 30E
	map.AddMap(WM_QUERYNEWPALETTE);	// 30F
	map.AddMap(WM_PALETTEISCHANGING);// 0310
	map.AddMap(WM_PALETTECHANGED);	// 311
	map.AddMap(WM_HOTKEY);		// 312
	map.AddMap(WM_PRINT);		// 317
	map.AddMap(WM_PRINTCLIENT);	// 318
	map.AddMap(DM_GETDEFID);	// WM_USER+0
	map.AddMap(DM_SETDEFID);	// WM_USER+1
	map.AddMap(TB_ENABLEBUTTON);	// WM_USER+1
	map.AddMap(RB_INSERTBANDA);	// WM_USER+1
	map.AddMap(DM_REPOSITION);	// WM_USER+2
	map.AddMap(TB_CHECKBUTTON);	// WM_USER+2
	map.AddMap(RB_DELETEBAND);	// WM_USER+2
	map.AddMap(TB_PRESSBUTTON);	// WM_USER+3
	map.AddMap(RB_GETBARINFO);	// WM_USER+3
	map.AddMap(TB_HIDEBUTTON);	// WM_USER+4
	map.AddMap(RB_SETBARINFO);	// WM_USER+4
	map.AddMap(TB_INDETERMINATE);	// WM_USER+5
	map.AddMap(RB_GETBANDINFO);	// WM_USER+5
	map.AddMap(TB_MARKBUTTON);	// WM_USER+6
	map.AddMap(RB_SETBANDINFOA);	// WM_USER+6
	map.AddMap(RB_SETPARENT);	// WM_USER+7
	map.AddMap(RB_HITTEST);		// WM_USER+8
	map.AddMap(TB_ISBUTTONENABLED);	// WM_USER+9
	map.AddMap(RB_GETRECT);		// WM_USER+9
	map.AddMap(TB_ISBUTTONCHECKED);	// WM_USER+10
	map.AddMap(RB_INSERTBANDW);	// WM_USER+10
	map.AddMap(TB_ISBUTTONPRESSED);	// WM_USER+11
	map.AddMap(RB_SETBANDINFOW);	// WM_USER+11
	map.AddMap(TB_ISBUTTONHIDDEN);	// WM_USER+12
	map.AddMap(RB_GETBANDCOUNT);	// WM_USER+12
	map.AddMap(TB_ISBUTTONINDETERMINATE); // WM_USER+13
	map.AddMap(RB_GETROWCOUNT);	// WM_USER+13
	map.AddMap(TB_ISBUTTONHIGHLIGHTED); // WM_USER+14
	map.AddMap(RB_GETROWHEIGHT);	// WM_USER+14
	map.AddMap(RB_IDTOINDEX);	// WM_USER+16
	map.AddMap(TB_SETSTATE);	// WM_USER+17
	map.AddMap(RB_GETTOOLTIPS);	// WM_USER+17
	map.AddMap(TB_GETSTATE);	// WM_USER+18
	map.AddMap(RB_SETTOOLTIPS);	// WM_USER+18
	map.AddMap(TB_ADDBITMAP);	// WM_USER+19
	map.AddMap(RB_SETBKCOLOR);	// WM_USER+19
	map.AddMap(TB_ADDBUTTONSA);	// WM_USER+20
	map.AddMap(RB_GETBKCOLOR);	// WM_USER+20
	map.AddMap(TB_INSERTBUTTONA);	// WM_USER+21
	map.AddMap(RB_SETTEXTCOLOR);	// WM_USER+21
	map.AddMap(TB_DELETEBUTTON);	// WM_USER+22
	map.AddMap(RB_GETTEXTCOLOR);	// WM_USER+22
	map.AddMap(TB_GETBUTTON);	// WM_USER+23
	map.AddMap(RB_SIZETORECT);	// WM_USER+23
	map.AddMap(TB_BUTTONCOUNT);	// WM_USER+24
	map.AddMap(RB_BEGINDRAG);	// WM_USER+24
	map.AddMap(TB_COMMANDTOINDEX);	// WM_USER+25
	map.AddMap(RB_ENDDRAG);		// WM_USER+25
	map.AddMap(TB_SAVERESTOREA);	// WM_USER+26
	map.AddMap(RB_DRAGMOVE);	// WM_USER+26
	map.AddMap(TB_CUSTOMIZE);	// WM_USER+27
	map.AddMap(RB_GETBARHEIGHT);	// WM_USER+27
	map.AddMap(TB_ADDSTRINGA);	// WM_USER+28
	map.AddMap(RB_GETBANDINFOW);	// WM_USER+28
	map.AddMap(TB_GETITEMRECT);	// WM_USER+29
	map.AddMap(RB_GETBANDINFOA);	// WM_USER+29
	map.AddMap(TB_BUTTONSTRUCTSIZE);// WM_USER+30
	map.AddMap(RB_MINIMIZEBAND);	// WM_USER+30
	map.AddMap(TB_SETBUTTONSIZE);	// WM_USER+31
	map.AddMap(RB_MAXIMIZEBAND);	// WM_USER+31
	map.AddMap(TB_SETBITMAPSIZE);	// WM_USER+32
	map.AddMap(TB_AUTOSIZE);	// WM_USER+33
	map.AddMap(RB_GETBANDBORDERS);	// WM_USER+34
	map.AddMap(TB_GETTOOLTIPS);	// WM_USER+35
	map.AddMap(RB_SHOWBAND);	// WM_USER+35
	map.AddMap(TB_SETTOOLTIPS);	// WM_USER+36
	map.AddMap(TB_SETPARENT);	// WM_USER+37
	map.AddMap(RB_SETPALETTE);	// WM_USER+37
	map.AddMap(RB_GETPALETTE);	// WM_USER+38
	map.AddMap(TB_SETROWS);		// WM_USER+39
	map.AddMap(RB_MOVEBAND);	// WM_USER+39
	map.AddMap(TB_GETROWS);		// WM_USER+40
	map.AddMap(TB_GETBITMAPFLAGS);	// WM_USER+41
	map.AddMap(TB_SETCMDID);	// WM_USER+42
	map.AddMap(TB_CHANGEBITMAP);	// WM_USER+43
	map.AddMap(TB_GETBITMAP);	// WM_USER+44
	map.AddMap(TB_GETBUTTONTEXTA);	// WM_USER+45
	map.AddMap(TB_REPLACEBITMAP);	// WM_USER+46
	map.AddMap(TB_SETINDENT);	// WM_USER+47
	map.AddMap(TB_SETIMAGELIST);	// WM_USER+48
	map.AddMap(TB_GETIMAGELIST);	// WM_USER+49
	map.AddMap(TB_LOADIMAGES);	// WM_USER+50
	map.AddMap(TB_GETRECT);		// WM_USER+51
	map.AddMap(TB_SETHOTIMAGELIST);	// WM_USER+52
	map.AddMap(TB_GETHOTIMAGELIST);	// WM_USER+53
	map.AddMap(TB_SETDISABLEDIMAGELIST); // WM_USER+54
	map.AddMap(TB_GETDISABLEDIMAGELIST); // WM_USER+55
	map.AddMap(TB_SETSTYLE);	// WM_USER+56
	map.AddMap(TB_GETSTYLE);	// WM_USER+57
	map.AddMap(TB_GETBUTTONSIZE);	// WM_UER+58
	map.AddMap(TB_SETBUTTONWIDTH);	// WM_USER+59
	map.AddMap(TB_SETMAXTEXTROWS);	// WM_USER+60
	map.AddMap(TB_GETTEXTROWS);	// WM_USER+61
	map.AddMap(TB_GETOBJECT);	// WM_USER+62
	map.AddMap(TB_GETBUTTONINFOW);	// WM_USER+63
	map.AddMap(TB_SETBUTTONINFOW);	// WM_USER+64
	map.AddMap(TB_GETBUTTONINFOA);	// WM_USER+65
	map.AddMap(TB_SETBUTTONINFOA);	// WM_USER+66
	map.AddMap(TB_INSERTBUTTONW);	// WM_USER+67
	map.AddMap(TB_ADDBUTTONSW);	// WM_USER+68
	map.AddMap(TB_HITTEST);		// WM_USER+69
	map.AddMap(TB_SETDRAWTEXTFLAGS);// WM_USER+70
	map.AddMap(TB_GETHOTITEM);	// WM_USER+71
	map.AddMap(TB_SETHOTITEM);	// WM_USER+72
	map.AddMap(TB_SETANCHORHIGHLIGHT); // WM_USER+73
	map.AddMap(TB_GETANCHORHIGHLIGHT); // WM_USER+74
	map.AddMap(TB_GETBUTTONTEXTW);	// WM_USER+75
	map.AddMap(TB_SAVERESTOREW);	// WM_USER+76
	map.AddMap(TB_ADDSTRINGW);	// WM_USER+77
	map.AddMap(TB_MAPACCELERATOR);	// WM_USER+78
	map.AddMap(TB_GETINSERTMARK);	// WM_USER+79
	map.AddMap(TB_SETINSERTMARK);	// WM_USER+80
	map.AddMap(TB_INSERTMARKHITTEST); // WM_USER+81
	map.AddMap(TB_MOVEBUTTON);	// WM_USER+82
	map.AddMap(TB_GETMAXSIZE);	// WM_USER+83
	map.AddMap(TB_SETEXTENDEDSTYLE);// WM_USER+84
	map.AddMap(TB_GETEXTENDEDSTYLE);// WM_USER+85
	map.AddMap(TB_GETPADDING);	// WM_USER+86
	map.AddMap(TB_SETPADDING);	// WM_USER+87
	map.AddMap(TB_SETINSERTMARKCOLOR); // WM_USER+88
	map.AddMap(TB_GETINSERTMARKCOLOR); // WM_USER+89
	map.AddMap(TB_MAPACCELERATORW);	// WM_USER+90
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CScreenCaptureDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScreenCaptureDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CScreenCaptureDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CScreenCaptureDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CScreenCaptureDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CScreenCaptureDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnClose();
}

void CScreenCaptureDlg::OnPrintscreen() 
   {
    CBitmap * bmp = c_PrintScreen.GetBitmap();
    if(bmp != NULL)
       { /* has bitmap */
	c_Bitmap.SetBitmap((HBITMAP)(*bmp));
       } /* has bitmap */
	
}

void CScreenCaptureDlg::OnCopy() 
   {
    CBitmap * bmp = c_Copy.GetBitmap();
    if(bmp != NULL)
       { /* has bitmap */
	OpenClipboard();
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP, (HBITMAP)(*bmp));
	CloseClipboard();
	bmp->Detach();
       } /* has bitmap */
}

void CScreenCaptureDlg::OnBkcolor() 
   {
    COLORREF color = c_Copy.GetFillColor();
    CColorDialog dlg(color, CC_ANYCOLOR | CC_RGBINIT);
    if(dlg.DoModal() == IDOK)
       { /* OK */
	c_Copy.SetFillColor(dlg.m_cc.rgbResult);
	c_PrintScreen.SetFillColor(dlg.m_cc.rgbResult);
       } /* OK */
	
}

void CScreenCaptureDlg::OnExit() 
   {
    CDialog::OnOK();
   }

int CScreenCaptureDlg::inchesToPixels(int distance, CDC & dc)
      {
      return (dc.GetDeviceCaps(LOGPIXELSX) * distance) / 100;
      } // CRegister::inchesToPixels

void CScreenCaptureDlg::OnPrint() 
   {
    CBitmap * bmp = c_PrintScreen.GetBitmap();
    if(bmp == NULL)
       return;
    HANDLE dib = MakeDIB(bmp);
    if(dib == NULL)
       return;
    
    CPrintDialog dlg(FALSE,
		     PD_ALLPAGES |
		     PD_USEDEVMODECOPIES |
		     PD_NOPAGENUMS |
		     PD_HIDEPRINTTOFILE |
		     PD_NOSELECTION |
		     PD_RETURNDC);
    if(dlg.DoModal() != IDOK)
       return;
    CDC printerDC;
    printerDC.Attach(dlg.m_pd.hDC);

    DOCINFO info;
    ::ZeroMemory(&info, sizeof(info));
    info.lpszDocName = AfxGetAppName();
    printerDC.StartDoc(&info);
    printerDC.StartPage();
    // We compute the correct ratio based on the dpi of the display vs. the dpi of
    // the printer
    CClientDC screenDC(this);
    CSize screen(screenDC.GetDeviceCaps(LOGPIXELSX), screenDC.GetDeviceCaps(LOGPIXELSY));
    CSize printer(printerDC.GetDeviceCaps(LOGPIXELSX), printerDC.GetDeviceCaps(LOGPIXELSY));

    printerDC.SetMapMode(MM_ISOTROPIC);
    printerDC.SetWindowExt(screen.cx, screen.cy);
    printerDC.SetViewportExt(printer.cx, printer.cy);

    BITMAPINFOHEADER bmi;
    DibInfo(dib, &bmi);
#define LEFT_MARGIN 50
#define TOP_MARGIN  50
    PrintDIB(&printerDC, dib,
	     inchesToPixels(LEFT_MARGIN, printerDC),
	     inchesToPixels(TOP_MARGIN, printerDC),
	     bmi.biWidth, bmi.biHeight);

    FreeDIB(dib);

    printerDC.EndPage();
    printerDC.EndDoc();
}

void CScreenCaptureDlg::OnClear() 
   {
    c_Messages.ResetContent();
   }

/****************************************************************************
*                      CScreenCaptureDlg::OnHookMessage
* Inputs:
*       WPARAM wParam: Message ID
*	LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Logs the message
****************************************************************************/

LRESULT CScreenCaptureDlg::OnHookMessage(WPARAM wParam, LPARAM)
    {
     CString s;
     s.Format(_T("0x%04x"), wParam);
     CString text;
     if(map.Lookup(wParam, text))
	s += _T(" ") + text;
     else
	{ /* might be registered */
	 if(wParam >= 0xC000)
	    { /* registered message */
	     TCHAR buffer[512];
	     UINT len = ::GlobalGetAtomName(wParam, buffer, sizeof(buffer)/sizeof(TCHAR));
	     if(len > 0)
		s += _T(" ");
	     s += buffer;
	    } /* registered message */
	} /* might be registered */
     c_Messages.AddString(s);
     return 0;
    } // CScreenCaptureDlg::OnHookMessage
